'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserProvider = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _LoadUserException = require('./Exception/LoadUserException');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Loads user from db
 */
let UserProvider = exports.UserProvider = function () {
  /**
   * @param {String} retrieveUserResource
   * @param {Object} deepResourceService
   */
  function UserProvider(retrieveUserResource, deepResourceService) {
    _classCallCheck(this, UserProvider);

    this._retrieveUserResource = retrieveUserResource;
    this._deepResource = deepResourceService;
  }

  /**
   * @param {String} id
   * @param {Function} callback
   */


  _createClass(UserProvider, [{
    key: 'loadUserByIdentityId',
    value: function loadUserByIdentityId(id, callback) {
      if (!this._retrieveUserResource) {
        callback(null, null);
        return;
      }

      let retrieveUserResource = this._deepResource.get(this._retrieveUserResource);

      // authScope(null) forces deep-resource to use cognito default credentials
      retrieveUserResource.request({ Id: id }).authScope(null).retry(3).disableCache().send(response => {
        if (response.error) {
          callback(new _LoadUserException.LoadUserException(id, response.error), null);
          return;
        }

        return callback(null, response.data);
      });
    }
  }]);

  return UserProvider;
}();